#include<iostream>
#include<vector>
#include<stack>
#include<queue>
#include<cmath>
using namespace std;

const int MAXN=2e5, MAXS=2*(1<<((int)ceil(log2(MAXN)))), INF=1e9;

vector<int> g[MAXN], pr[MAXN];
vector<int> ls;
pair<int, int> st[MAXS];
int t[MAXN], l[MAXN], indcs[MAXN];
int maxl=0;

void BuildTree(int n)
{
    queue<int> q, srtd;
    q.push(0);
    l[0]=0;

    while(!q.empty())
    {
        int idx=q.front();
        q.pop();

        srtd.push(idx);
        maxl=max(maxl, l[idx]);

        int gs=g[idx].size();
        for(int i=0; i<gs; i++)
        {
            q.push(g[idx][i]);
            l[g[idx][i]]=l[idx]+1, pr[g[idx][i]].push_back(idx);
        }
    }

    int ts=0;
    while(!srtd.empty())
    {
        t[ts]=srtd.front(), indcs[srtd.front()]=ts;
        srtd.pop();

        if(l[t[ts]]==ls.size())
        {
            ls.push_back(ts);
        }

        ts++;
    }

    return;
}

void BuildSegTree(int n)
{
    int s=(1<<(int)ceil(log2(n)));

    for(int i=0; i<n; i++)
    {
        st[i+s]={t[i], t[i]};
    }

    for(int i=n; i<s; i++)
    {
        st[i+s]={0, 0};
    }

    for(int i=s-1; i>0; i--)
    {
        st[i]={min(st[2*i].first, st[2*i+1].first), max(st[2*i].second, st[2*i+1].second)};
    }

    return;
}

void PrepAncestors(int n)
{
    for(int idx=1; idx<n; idx++)
    {
        for(int i=1; (1<<i)<=l[idx]; i++)
        {
            pr[idx].push_back(pr[pr[idx][i-1]][i-1]);
        }
    }

    return;
}

int GetAncestor(int idx, int k)
{
    if(k==0)
    {
        return idx;
    }

    int i=0;
    while((1<<i)<=k)
    {
        i++;
    }

    return GetAncestor(pr[idx][i-1], k-(1<<(i-1)));
}

pair<int, int> GetArea(int idx, int k, int from, int to)
{
    int l1=from, r1=to;
    while(l1!=r1)
    {
        if(l1+1==r1)
        {
            if(GetAncestor(t[l1], k)==idx)
            {
                r1=l1;
            }
            else
            {
                l1=r1;
            }
            break;
        }

        int mid=(l1+r1)/2;
        int anc=GetAncestor(t[mid], k);

        if(anc==idx)
        {
            r1=mid;
        }
        else if(indcs[anc]<indcs[idx])
        {
            l1=mid+1;
        }
        else
        {
            r1=mid-1;
        }
    }
    from=l1;

    l1=from, r1=to;
    while(l1!=r1)
    {
        if(l1+1==r1)
        {
            if(GetAncestor(t[r1], k)==idx)
            {
                l1=r1;
            }
            else
            {
                r1=l1;
            }
            break;
        }

        int mid=(l1+r1)/2;
        int anc=GetAncestor(t[mid], k);

        if(anc==idx)
        {
            l1=mid;
        }
        else
        {
            r1=mid-1;
        }
    }
    to=l1;

    return {from, to};
}

pair<int, int> GetMin(int n, int from, int to)
{
    int s=(1<<(int)ceil(log2(n)));
    from+=s, to+=s;

    pair<int, int> res=make_pair(INF, 0);

    while(from>0 && from<=to)
    {
        if(from%2==1)
        {
            res.first=min(res.first, st[from].first), res.second=max(res.second, st[from].second);
            from++;
        }

        if(to%2==0)
        {
            res.first=min(res.first, st[to].first), res.second=max(res.second, st[to].second);
            to--;
        }

        from/=2, to/=2;
    }

    return res;
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);

    int n;
    cin >> n;

    for(int i=1; i<n; i++)
    {
        int a;
        cin >> a;
        a--;

        g[a].push_back(i);
    }

    BuildTree(n);
    BuildSegTree(n);
    PrepAncestors(n);

    int m;
    cin >> m;

    pair<int, int> ans=make_pair(-1, -1);
    bool b;
    while(m--)
    {
        int idx, k;
        cin >> idx >> k;
        idx--;

        int from=ls[l[idx]+k], to;
        if(l[idx]+k==maxl)
        {
            to=n-1;
        }
        else
        {
            to=ls[l[idx]+k+1]-1;
        }

        pair<int, int> p=GetArea(idx, k, from, to);
        pair<int, int> temp=GetMin(n, p.first, p.second);

        if(ans.first==-1)
        {
            ans=temp;
            b=true;
        }
        else if(b)
        {
            if(temp.second<ans.first)
            {
                ans=make_pair(temp.second, ans.first);
                b=false;
            }
            else if(temp.first>ans.second)
            {
                ans=make_pair(ans.second, temp.first);
                b=false;
            }
            else if(temp.first<ans.second)
            {
                ans=make_pair(temp.first, ans.second);
            }
            else
            {
                ans=make_pair(ans.second, temp.first);
            }
        }
        else
        {
            if(ans.first>temp.second)
            {
                ans.first=temp.second;
            }

            if(ans.second<temp.first)
            {
                ans.second=temp.first;
            }
        }
    }

    if(b)
    {
        cout << ans.first+1 << " " << ans.first+1 << "\n";
    }
    else
    {
        cout << ans.first+1 << " " << ans.second+1 << "\n";
    }

    return 0;
}
