#include <algorithm>
#include <utility>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n;
int mn0, mx0;
int lev[MAXN + 5];
vector<int> G[MAXN + 5];
vector<int> queries[MAXN + 5];

void DFS1(int u, int p)
{
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            lev[v] = lev[u] + 1;
            DFS1(v, u);
        }
    }
}

vector< pair<int, int> > DFS2(int u, int p)
{
    vector< pair<int, int> > vec;
    vec.push_back(make_pair(lev[u], u));
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            auto t = DFS2(v, u);
            vec.insert(vec.end(), t.begin(), t.end());
        }
    }

    sort(vec.begin(), vec.end());
    for (int i = 0; i < queries[u].size(); ++ i)
    {
        int q = queries[u][i];
        int mn = vec[lower_bound(vec.begin(), vec.end(), make_pair(q, 0)) - vec.begin()].second;
        mn0 = max(mn0, mn);
        int mx = vec[lower_bound(vec.begin(), vec.end(), make_pair(q + 1, 0)) - vec.begin() - 1].second;
        mx0 = min(mx0, mx);
    }
    return vec;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 2; i <= n; ++ i)
    {
        int p;
        cin >> p;
        G[p].push_back(i);
        G[i].push_back(p);
    }

    lev[1] = 1;
    DFS1(1, -1);

    int m;
    cin >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, k;
        cin >> u >> k;
        queries[u].push_back(lev[u] + k);
    }

    mn0 = 0;
    mx0 = n + 1;
    DFS2(1, -1);

    cout << min(mn0, mx0) << " " << mn0 << endl;

    return 0;
}
