#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, m;
int p[MAXN + 5];
vector<int> num;
int wh[MAXN + 5];
int lev[MAXN + 5];
vector<int> G[MAXN + 5];
pair<int, int> tree[4 * MAXN + 5];

bool subtask3()
{
    for (int i = 2; i <= n; ++ i)
    {
        if (p[i] != i - 1) return false;
    }
    return true;
}

void DFS1(int u, int p)
{
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            lev[v] = lev[u] + 1;
            DFS1(v, u);
        }
    }
}

void DFS2(int u, int p, int k)
{
    if (lev[u] == k)
    {
        num.push_back(u);
        return;
    }

    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p) DFS2(v, u, k);
    }
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v].first = tree[v].second = wh[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v].first = min(tree[2 * v].first, tree[2 * v + 1].first);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

void update(int v, int l, int r, int pos)
{
    if (r < pos or pos < l) return;
    if (l == r)
    {
        tree[v].first = tree[v].second = wh[l];
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, pos);
    update(2 * v + 1, mid + 1, r, pos);
    tree[v].first = min(tree[2 * v].first, tree[2 * v + 1].first);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i];
        G[p[i]].push_back(i);
        G[i].push_back(p[i]);
    }

    if (subtask3())
    {
        cin >> m;

        int mn = n + 1, mx = 0;
        for (int i = 1; i <= m; ++ i)
        {
            int u, k;
            cin >> u >> k;
            mn = min(mn, u + k);
            mx = max(mx, u + k);
        }

        cout << mn << " " << mx << endl;
    }
    else
    {
        lev[1] = 1;
        DFS1(1, -1);

        cin >> m;

        vector< pair<int, int> > v;
        for (int i = 1; i <= m; ++ i)
        {
            int u, k;
            cin >> u >> k;
            num.clear();
            DFS2(u, p[u], lev[u] + k);
            for (int j = 0; j < num.size(); ++ j)
            {
                v.push_back(make_pair(num[j], i));
            }
        }

        sort(v.begin(), v.end());

        int br = 0;
        bool flag = false;
        int l0 = 0, r0 = n + 1;
        for (int i = 0; i < v.size(); ++ i)
        {
            if (wh[v[i].second] == 0) br++;
            wh[v[i].second] = v[i].first;
            if (br == m)
            {
                if (!flag)
                {
                    flag = true;
                    build(1, 1, m);
                }
                else update(1, 1, m, v[i].second);
                int l = tree[1].first, r = tree[1].second;
                if (r - l + 1 < r0 - l0 + 1)
                {
                    l0 = l;
                    r0 = r;
                }
                else if (r - l + 1 == r0 - l0 + 1 and l < l0)
                {
                    l0 = l;
                    r0 = r;
                }
            }
        }

        cout << l0 << " " << r0 << endl;
    }

    return 0;
}
