#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, m;
int cnt = 0;
int wh[MAXN + 5];
int lev[MAXN + 5];
vector<int> G[MAXN + 5];
pair<int, int> lims[MAXN + 5];
pair<int, int> tree[4 * MAXN + 5];
vector< pair<int, int> > levs[MAXN + 5];

void DFS(int u, int p)
{
    if (G[u].size() == 1)
    {
        cnt++;
        lims[u].first = lims[u].second = cnt;
    }
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            lev[v] = lev[u] + 1;
            DFS(v, u);
            lims[u].first = min(lims[u].first, lims[v].first);
            lims[u].second = max(lims[u].second, lims[v].second);
        }
    }
    levs[lev[u]].push_back(make_pair(lims[u].first, u));
}

void build(int v, int l, int r)
{
    if (l == r)
    {
        tree[v].first = tree[v].second = wh[l];
        return;
    }

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    tree[v].first = min(tree[2 * v].first, tree[2 * v + 1].first);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

void update(int v, int l, int r, int pos)
{
    if (r < pos or pos < l) return;
    if (l == r)
    {
        tree[v].first = tree[v].second = wh[l];
        return;
    }

    int mid = (l + r) / 2;
    update(2 * v, l, mid, pos);
    update(2 * v + 1, mid + 1, r, pos);
    tree[v].first = min(tree[2 * v].first, tree[2 * v + 1].first);
    tree[v].second = max(tree[2 * v].second, tree[2 * v + 1].second);
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 2; i <= n; ++ i)
    {
        int p;
        cin >> p;
        G[p].push_back(i);
        G[i].push_back(p);
    }

    lev[1] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        lims[i].first = n + 1;
    }
    DFS(1, -1);

    for (int i = 1; i <= n; ++ i)
    {
        sort(levs[i].begin(), levs[i].end());
    }

    cin >> m;

    vector< pair<int, int> > v;
    for (int i = 1; i <= m; ++ i)
    {
        int u, k;
        cin >> u >> k;
        k += lev[u];
        int l = lower_bound(levs[k].begin(), levs[k].end(), make_pair(lims[u].first, 0)) - levs[k].begin();
        int r = lower_bound(levs[k].begin(), levs[k].end(), make_pair(lims[u].second + 1, 0)) - levs[k].begin();
        for (int j = l; j < r; ++ j)
        {
            v.push_back(make_pair(levs[k][j].second, i));
        }
    }

    sort(v.begin(), v.end());

    int br = 0;
    bool flag = false;
    int l0 = 0, r0 = n + 1;
    for (int i = 0; i < v.size(); ++ i)
    {
        if (wh[v[i].second] == 0) br++;
        wh[v[i].second] = v[i].first;
        if (br == m)
        {
            if (!flag)
            {
                flag = true;
                build(1, 1, m);
            }
            else update(1, 1, m, v[i].second);
            int l = tree[1].first, r = tree[1].second;
            if (r - l + 1 < r0 - l0 + 1)
            {
                l0 = l;
                r0 = r;
            }
            else if (r - l + 1 == r0 - l0 + 1 and l < l0)
            {
                l0 = l;
                r0 = r;
            }
        }
    }

    cout << l0 << " " << r0 << endl;

    return 0;
}
