#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, m;
int cnt = 0;
int wh[MAXN + 5];
int lev[MAXN + 5];
vector<int> G[MAXN + 5];
pair<int, int> lims[MAXN + 5];
vector< pair<int, int> > levs[MAXN + 5];

void DFS(int u, int p)
{
    if (G[u].size() == 1)
    {
        cnt++;
        lims[u].first = lims[u].second = cnt;
    }
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        if (v != p)
        {
            lev[v] = lev[u] + 1;
            DFS(v, u);
            lims[u].first = min(lims[u].first, lims[v].first);
            lims[u].second = max(lims[u].second, lims[v].second);
        }
    }
    levs[lev[u]].push_back(make_pair(lims[u].first, u));
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 2; i <= n; ++ i)
    {
        int p;
        cin >> p;
        G[p].push_back(i);
        G[i].push_back(p);
    }

    lev[1] = 1;
    for (int i = 1; i <= n; ++ i)
    {
        lims[i].first = n + 1;
    }
    DFS(1, -1);

    for (int i = 1; i <= n; ++ i)
    {
        sort(levs[i].begin(), levs[i].end());
    }

    cin >> m;
    
    int l0 = 0, r0 = n + 1;
    for (int i = 1; i <= m; ++ i)
    {
        int u, k;
        cin >> u >> k;
        k += lev[u];
        int l = levs[k][lower_bound(levs[k].begin(), levs[k].end(), make_pair(lims[u].first, 0)) - levs[k].begin()].second;
        int r = levs[k][lower_bound(levs[k].begin(), levs[k].end(), make_pair(lims[u].second + 1, 0)) - levs[k].begin() - 1].second;
        l0 = max(l, l0);
        r0 = min(r, r0);
    }
    
    cout << r0 << " " << l0 << endl;

    return 0;
}
