#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=2e5+10;
struct Interv{
    int x, y, ind;
};
vector <int> v[MAXN], lst[MAXN];
vector <int> tree[2][MAXN];
vector <Interv> inter[MAXN];
int sp1[32][MAXN], sp2[32][MAXN];
int level[MAXN], lind[MAXN], minint[MAXN], maxint[MAXN];
int n, maxst, maxl;
int ql, qr, qind;
bool used[MAXN];
bool cmp1(Interv a, Interv b) {
    if (a.x==b.x) return a.y<b.y;
    return a.x<b.x;
}
bool cmp2(Interv a, Interv b) {
    if (a.y==b.y) return a.x>b.x;
    return a.y<b.y;
}
void build_tree(int node, int ind, int l, int r) {
    if (l==r) {
        tree[0][ind][node]=lst[ind][l];
        tree[1][ind][node]=lst[ind][l];
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,ind,l,mid);
    build_tree(node*2+1,ind,mid+1,r);
    tree[0][ind][node]=tree[0][ind][node*2];
    tree[1][ind][node]=tree[1][ind][node*2];
    if (mid+1<=r) {
        tree[0][ind][node]=min(tree[0][ind][node],tree[0][ind][node*2+1]);
        tree[1][ind][node]=max(tree[1][ind][node],tree[1][ind][node*2+1]);
    }
}
int query(int node, int ind, int l, int r) {
    if (ql>r || qr<l) return -1;
    if (l>=ql && r<=qr) {
        return tree[qind][ind][node];
    }
    int mid=(l+r)/2;
    int s1, s2;
    s1=query(node*2,ind,l,mid);
    s2=query(node*2+1,ind,mid+1,r);
    if (s1==-1) return s2;
    if (s2==-1) return s1;
    if (qind==0) return min(s1,s2);
    else return max(s1,s2);
}
void dfs(int x) {
    maxl=max(maxl,level[x]);
    lst[level[x]].push_back(x);
    lind[x]=lst[level[x]].size()-1;
    for (auto i:v[x]) {
        level[i]=level[x]+1;
        dfs(i);
    }
    if (v[x].size()==0) sp1[0][x]=sp2[0][x]=-1;
    else {
        sp1[0][x]=v[x][0];
        sp2[0][x]=v[x][v[x].size()-1];
    }
}
void sparce_table() {
    maxst=0;
    int st=2;
    for (int i=1;st<n;i++) {
        for (int j=1;j<=n;j++) {
            if (sp1[i-1][j]==-1) sp1[i][j]=-1;
            else sp1[i][j]=sp1[i-1][sp1[i-1][j]];
            if (sp2[i-1][j]==-1) sp2[i][j]=-1;
            else sp2[i][j]=sp2[i-1][sp2[i-1][j]];
        }
        maxst=i;
        st*=2;
    }
}
int find_first(int x, int lev) {
    int st=maxst;
    while (st>=0) {
        if (sp1[st][x]!=-1 && level[sp1[st][x]]<=lev) x=sp1[st][x];
        st--;
    }
    return lind[x];
}
int find_last(int x, int lev) {
    int st=maxst;
    while (st>=0) {
        if (sp2[st][x]!=-1 && level[sp2[st][x]]<=lev) x=sp2[st][x];
        st--;
    }
    return lind[x];
}
void interval() {
    for (int i=0;i<=maxl;i++) {
        sort(inter[i].begin(),inter[i].end(),cmp1);
        for (int j=0;j<inter[i].size();j++) {
            if (j>0 && inter[i][j-1].x==inter[i][j].x) used[inter[i][j].ind]=true;
        }
        sort(inter[i].begin(),inter[i].end(),cmp2);
        for (int j=0;j<inter[i].size();j++) {
            if (j>0 && inter[i][j-1].y==inter[i][j].y) used[inter[i][j].ind]=true;
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int p;
    cin >> n;
    for (int i=2;i<=n;i++) {
        cin >> p;
        v[p].push_back(i);
    }
    level[1]=1;
    dfs(1);
    for (int i=1;i<=maxl;i++) {
        for (int j=0;j<2*lst[i].size();j++) {
            tree[0][i].push_back(0);
            tree[1][i].push_back(0);
        }
        build_tree(1,i,0,lst[i].size()-1);
    }
    sparce_table();
    int q, u, x, curl;
    cin >> q;
    for (int i=0;i<q;i++) {
        cin >> u >> x;
        curl=level[u]+x;
        ql=find_first(u,curl);
        qr=find_last(u,curl);
        qind=0;
        minint[i]=query(1,curl,0,lst[curl].size()-1);
        qind=1;
        maxint[i]=query(1,curl,0,lst[curl].size()-1);
        inter[curl].push_back({ql,qr,i});
        ///cout << ql << ' ' << qr << ' ' << minint[i] << ' ' << maxint[i] << endl;
    }
    interval();
    int ansbeg, anse, ind1, ind2, brq=0;
    ansbeg=n+1;
    anse=0;
    for (int i=0;i<q;i++) {
        if (used[i]) continue;
        if (ansbeg>maxint[i]) {
            ansbeg=maxint[i];
            ind1=i;
        }
        if (anse<minint[i]) {
            anse=minint[i];
            ind2=i;
        }
        brq++;
    }
    if (brq==1) {
        cout << min(ansbeg,anse) << ' ' << max(ansbeg,anse) << endl;
        return 0;
    }
    if (ind1==ind2) {
        int mins, maxs;
        mins=-1;
        for (int i=0;i<q;i++) {
            if (used[i]) continue;
            if (mins==-1) {
                mins=minint[i];
                maxs=maxint[i];
            } else {
                mins=min(mins,minint[i]);
                maxs=max(maxs,maxint[i]);
            }
        }
        if (ansbeg-mins<=maxs-anse) {
            anse=ansbeg;
            ansbeg=mins;
        } else {
            ansbeg=anse;
            anse=maxs;
        }
    }
    if (ansbeg>anse) swap(ansbeg,anse);
    cout << ansbeg << ' ' << anse << endl;
    return 0;
}
/**
7
1 1 2 3 2 1
2
1 1
3 1
**/
