#include <iostream>

#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 3;
int x[MAXN], y[MAXN];

int64_t calc_distance(int startx, int starty, int k) {
    int64_t distance = 0;
    int max_diff = 0;

    for (int i = 0; i < k; ++i) {
        int curr_diff = abs(startx - x[i]) + abs(starty - y[i]);
        max_diff = max(max_diff, curr_diff);

        distance += 2ll * curr_diff;
    }

    return distance - max_diff;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n, k;
    cin >> m >> n >> k;

    int64_t sumx = 0, sumy = 0;
    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
        sumx += 1ll * x[i];
        sumy += 1ll * y[i];
    }

    int startx = sumx / k, starty = sumy / k;
    int64_t res = calc_distance(startx, starty, k);

    bool not_div_x = false;
    if (sumx % k != 0) {
        not_div_x = true;
        res = min(res, calc_distance(startx + 1, starty, k));
    }

    bool not_div_y = false;
    if (sumy % k != 0) {
        not_div_y = true;
        res = min(res, calc_distance(startx, starty + 1, k));
    }

    if (not_div_x and not_div_y) {
        res = min(res, calc_distance(startx + 1, starty + 1, k));
    }

    cout << res << endl;
return 0;
}
