#include <iostream>

#define endl '\n'

using namespace std;

const int MAXN = 1e5 + 3, MAX_CHANGES = 6, MAX_BONUS = 1000;
int x[MAXN], y[MAXN];
int changes[MAX_CHANGES][2] = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}, {-1, -1}, {1, 1}};

bool check_coord(int value, int limit) {
    return value > 0 and value <= limit;
}

int64_t calc_distance(int startx, int starty, int k) {
    int64_t distance = 0;
    int max_diff = 0;

    for (int i = 0; i < k; ++i) {
        int curr_diff = abs(startx - x[i]) + abs(starty - y[i]);
        max_diff = max(max_diff, curr_diff);

        distance += 2ll * curr_diff;
    }

    return distance - max_diff;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m, n, k;
    cin >> m >> n >> k;

    int64_t sumx = 0, sumy = 0;
    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
        sumx += 1ll * x[i];
        sumy += 1ll * y[i];
    }

    int startx = sumx / k, starty = sumy / k;
    int64_t res = calc_distance(startx, starty, k);

    /*for (int bonus = 1; bonus <= 10000; ++bonus) {
        for (int i = 0; i < MAX_CHANGES; ++i) {
            res = min(res, calc_distance(startx + bonus * changes[i][0], starty + bonus * changes[i][1], k));
        }
    }*/

    for (int bonusx = -MAX_BONUS; bonusx <= MAX_BONUS; ++bonusx) {
        for (int bonusy = -MAX_BONUS; bonusy <= MAX_BONUS; ++bonusy) {
            if (!check_coord(startx + bonusx, m) or !check_coord(starty + bonusy, n)) {
                continue;
            }

            res = min(res, calc_distance(startx + bonusx, starty + bonusy, k));
        }
    }

    cout << res << endl;
return 0;
}
