#include <iostream>
#include <vector>
#include <queue>

#define endl '\n'

using namespace std;

const int MAXN = 2e5 + 3;
int parent[MAXN];
vector<int> graph[MAXN];

pair<int, int> find_level(int vertex, int level) {
    queue<int> bfs;
    bfs.push(vertex);

    for (int i = 0; i < level; ++i) {
        int queue_size = (int) bfs.size();

        for (int j = 0; j < queue_size; ++j) {
            int currv = bfs.front();
            bfs.pop();

            for (int nextv : graph[currv]) {
                if (nextv != parent[currv]) {
                    bfs.push(nextv);
                }
            }
        }
    }

    int min_vertex = MAXN, max_vertex = -1;
    for (int i = 0; !bfs.empty(); ++i) {
        int currv = bfs.front();
        bfs.pop();

        min_vertex = min(min_vertex, currv);
        max_vertex = max(max_vertex, currv);
    }

    return {min_vertex, max_vertex};
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    parent[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> parent[i];
        --parent[i];
        graph[parent[i]].push_back(i);
        graph[i].push_back(parent[i]);
    }

    int m;
    cin >> m;

    int l = n + 1, r = -1;
    for (int i = 0; i < m; ++i) {
        int vertex, level;
        cin >> vertex >> level;
        --vertex;

        pair<int, int> targets = find_level(vertex, level);

        l = min(l, targets.second);
        r = max(r, targets.first);
    }

    ++l;
    ++r;

    if (l <= r) {
        cout << l << " " << r << endl;
    } else {
        cout << r << " " << r << endl;
    }
return 0;
}
