#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
using namespace std;

const int MAXN = 1048576;
const long long INF = 9876543219876543;

struct trgt
{
    long long x;
    long long y;
};

long long n, m;
int k;
long long x, y;
trgt houses[MAXN];
vector<long long> tryX, tryY;


bool cmpX(trgt A, trgt B)
{
    return A.x < B.x;
}

bool cmpY(trgt A, trgt B)
{
    return A.y < B.y;
}

long long currAns, ans;
long long maxDist;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n >> m;
    cin >> k;
    for(int i = 0; i < k; i++){
        cin >> houses[i].x >> houses[i].y;
    }

    sort(houses, houses+k, cmpX);
    tryX.push_back(houses[(k-1)/2].x);
    if(k % 2 == 0 && tryX[0] != houses[(k+1)/2].x){
        tryX.push_back(houses[(k+1)/2].x);
    }

    sort(houses, houses+k, cmpY);
    tryY.push_back(houses[(k-1)/2].y);
    if(k % 2 == 0 && tryY[0] != houses[(k+1)/2].y){
        tryY.push_back(houses[(k+1)/2].y);
    }


    ans = INF;
    for(auto x: tryX){
        for(auto y: tryY){
            currAns = 0;
            maxDist = 0;
            for(int i = 0; i < k; i++){
                long long dist = abs(x - houses[i].x) + abs(y - houses[i].y);
                if(dist > maxDist) maxDist = dist;
                currAns += 2*dist;
            }
            if(currAns - maxDist < ans) ans = currAns - maxDist;
        }
    }

    cout << ans << endl;

return 0;
}
