#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 1048576;

int n, m;
int p[MAXN];
int u, k;
bool used[MAXN];
bool fl;
vector<int> sys[MAXN];
vector<vector<int> > groups;
vector<int> currg;

void dfs(int curr, int pathLeft)
{
    if(fl){return;}
    if(pathLeft == 0){
        if(used[curr]){
            fl = true;
            return;
        }
        used[curr] = true;
        currg.push_back(curr);
        return;
    }
    for(int i = 0; i < sys[curr].size() && !fl; i++){
        dfs(sys[curr][i], pathLeft-1);
    }
}

int minL, ansl, ansr;
int cl, cr;

int level[MAXN];

void initDFS(int curr, int lvl)
{
    level[curr] = lvl;
    for(auto i: sys[curr]){
        initDFS(i, lvl+1);
    }
}

struct query
{
    int u, k;

    bool operator < (query A) const
    {
        if(level[u]+k != level[A.u]+A.k){
            return level[u]+k > level[A.u]+A.k;
        }
        return level[u] > level[A.u];
    }

};

vector<query> allq;

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for(int i = 1; i < n; i++){
        cin >> p[i];
        sys[p[i]].push_back(i+1);
    }
    initDFS(1, 0);
    cin >> m;
    for(int i = 0; i < m; i++){
        cin >> u >> k;
        allq.push_back({u, k});
    }
    sort(allq.begin(), allq.end());
    /*for(auto q: allq){
        cout << q.u << " " << q.k << endl;
    }*/

    for(auto q: allq){
        u = q.u;
        k = q.k;
        currg.clear();
        fl = false;
        dfs(u, k);
        sort(currg.begin(), currg.end());
        //currg.push_back(0);
        if(!fl && currg.size() > 0) groups.push_back(currg);
    }

    /*for(auto g: groups){
        for(auto outp: g){
            cout << outp << " ";
        }
        cout << endl;
    }*/

    minL = MAXN;

    int s = groups.size();
    for(int i = 0; i < s; i++){
        int scg = groups[i].size();
        fl = false;
        for(int h = 0; h < scg && !fl; h++){
            cl = groups[i][h];
            cr = 0;
            for(int j = 0; j < s && !fl; j++){
                if(i == j) continue;
                bool isF = false;
                for(int v = 0; v < groups[j].size() && !fl; v++){
                    if(groups[j][v] >= cl){
                        isF = true;
                        cr = max(cr, groups[j][v]);
                        break;
                    }
                }
                if(!isF){
                    fl = true;
                    break;
                }

            }
            if(!fl && (minL > cr-cl || (minL == cr-cl && cl < ansl))){
                minL = cr-cl;
                ansl = cl; ansr = cr;
            }
        }
    }

    cout << ansl << " " << ansr << endl;

return 0;
}
