#include <bits/stdc++.h>

const int MAXN = 3e3 + 10;

int p[MAXN];

std::vector<int> children[MAXN];

int depth[MAXN][MAXN];

std::pair<int, int> inter[MAXN];

void bfs(int s)
{
    std::queue<std::pair<int, int> > k;
    for(int& child : children[s])
    {
        k.push({child, 1});
    }

    while(!k.empty())
    {
        auto curr = k.front();
        k.pop();

        depth[s][curr.first] = curr.second;

        for(int& child : children[curr.first])
        {
            k.push({child, curr.second + 1});
        }
    }
}

int main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int n, m;
    std::cin >> n;

    for(int i = 2; i <= n; ++ i)
    {
        std::cin >> p[i];
        children[p[i]].push_back(i);
    }

    for(int i = 1; i <= n; ++ i)
    {
        if(children[i].size())
        {
            bfs(i);
        }
    }

    std::cin >> m;

    for(int i = 0; i < m; ++ i)
    {
        int u, d;
        std::cin >> u >> d;

        inter[i] = {0, MAXN};

        for(int j = 1; j <= n; ++ j)
        {
            if(depth[u][j] == d)
            {
                inter[i].first = std::max(inter[i].first, j);
                inter[i].second = std::min(inter[i].second, j);
            }
        }

        //std::cout << inter[i].first << ' ' << inter[i].second << '\n';
    }

    int l = MAXN, r = 0;

    for(int i = 0; i < m; ++ i)
    {
        l = std::min(l, inter[i].first);
        r = std::max(r, inter[i].second);
    }

    std::cout << l << ' ' << r;

    return 0;
}

