#include <bits/stdc++.h>

const int MAXN = 3e3 + 10;

int p[MAXN];

std::vector<int> children[MAXN];

int depth[MAXN][MAXN];

std::vector<int> inter[MAXN];

void bfs(int s)
{
    std::queue<std::pair<int, int> > k;
    for(int& child : children[s])
    {
        k.push({child, 1});
    }

    while(!k.empty())
    {
        auto curr = k.front();
        k.pop();

        depth[s][curr.first] = curr.second;

        for(int& child : children[curr.first])
        {
            k.push({child, curr.second + 1});
        }
    }
}

bool check(int l, int r, int m)
{
    for(int i = 0; i < m; ++ i)
    {
        bool is = false;
        for(int j = 0; j < inter[i].size(); ++ j)
        {
            if(l <= inter[i][j] && inter[i][j] <= r)
            {
                is = true;
            }
        }
        if(!is)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    std::ios_base::sync_with_stdio(false);

    int n, m;
    std::cin >> n;

    for(int i = 2; i <= n; ++ i)
    {
        std::cin >> p[i];
        children[p[i]].push_back(i);
    }

    for(int i = 1; i <= n; ++ i)
    {
        if(children[i].size())
        {
            bfs(i);
        }
    }

    std::cin >> m;

    for(int i = 0; i < m; ++ i)
    {
        int u, d;
        std::cin >> u >> d;

        for(int j = 1; j <= n; ++ j)
        {
            if(depth[u][j] == d)
            {
                inter[i].push_back(j);
            }
        }

        //std::cout << inter[i].first << ' ' << inter[i].second << '\n';
    }

    int l = 1, r = 1, ml, mr, min = MAXN;

    while(r <= n)
    {
        if(!check(l, r, m))
        {
            ++ r;
            continue;
        }
        if(r - l < min)
        {
            min = r - l;
            ml = l;
            mr = r;
        }
        ++ l;
    }

    std::cout << ml << ' ' << mr << '\n';

    return 0;
}


