#include <iostream>
#include <utility>
#include <math.h>

using namespace std;

double getSin(pair<int, int> p1, pair<int, int> p2){
    if(p1.first == p2.first){
        return 1;
    }
    if(p1.second == p2.second){
        return 0;
    }

    pair<int, int> p3;
    p3.first = p2.first;
    p3.second = p1.second;

    double a = (p3.first - p1.first) + (p3.second - p1.second);
    if(a < 0){
        a = -a;
    }

    double b = (p3.first - p2.first) + (p3.second - p2.second);
    if(b < 0){
        b = -b;
    }

    double c = sqrt(((a*a) + (b*b)));

    //cout<<"p1: "<<p1.first<<" "<<p1.second<<endl;
    //cout<<"p2: "<<p2.first<<" "<<p2.second<<endl;
    //cout<<"p3: "<<p3.first<<" "<<p3.second<<endl;
    //cout<<"a, b: "<<a<<" "<<b<<endl;

    double sin = b/c;

    if(sin < 0){
        sin = 1-sin;
    }

    return sin;
}

bool isPointOverLine(pair<int, int> p1, pair<int, int> p2, pair<int, int> point){
    if(getSin(p1, p2) <= getSin(p1, point)){
        return true;
    }else{
        return false;
    }
}

bool isPointInTriangle(pair<int, int> p1, pair<int, int> p2, pair<int, int> p3, pair<int, int> point){
    if((p1.first == point.first && p1.second == point.second) ||(p2.first == point.first && p2.second == point.second) ||(p3.first == point.first && p3.second == point.second)){
        return true;
    }

    if(isPointOverLine(p1, p2, point) == true && isPointOverLine(p1, p3, point) == false && isPointOverLine(p3, p2, point) == true){
        return true;
    }else{
        return false;
    }
}

#define maxn 100000

int M, N, lK, numP = 0, minWalk = -1;
pair<int, int> K[maxn];
pair<int, int> points[maxn];

int getDistanceBetween2P(pair<int, int> p1, pair<int, int> p2){
    int a = p1.first - p2.first;
    if(a < 0){
        a = -a;
    }

    int b = p1.second - p2.second;
    if(b < 0){
        b = -b;
    }

    return (a+b);
}

int getDistance(pair<int, int> point){
    int total = 0;
    int longest = -1;

    for(int i = 0; i < lK; i++){
        int thisDistance = getDistanceBetween2P(K[i], point);

        if(longest == -1 || longest < thisDistance){
            longest = thisDistance;
        }

        total += thisDistance;
    }

    total -= longest;

    total = total*2;

    total += longest;

    return total;
}

int main(){

    cin>>M>>N>>lK;

    for(int i = 0; i < lK; i++){
        cin>>K[i].first>>K[i].second;
    }

    for(int i = 0; i < M; i++){
        for(int j = 0; j < N; j++){
            pair<int, int> newPoint;
            newPoint.first = i+1;
            newPoint.second = j+1;

            int thisWalk = getDistance(newPoint);
            if(minWalk == -1 || minWalk > thisWalk){
                minWalk = thisWalk;
            }

            /*for(int k = 2; k < lK; k++){
                if(isPointInTriangle(K[0], K[1], K[i], newPoint) == true){
                    points[numP] = newPoint;
                    numP++;
                    continue;
                }
            }*/
        }
    }

    cout<<minWalk<<endl;

    /*for(int i = 0; i < numP; i++){
        cout<<"This is point "<<i<<"   x:"<<points[i].first<<"   y:"<<points[i].second<<endl;
    }*/

    /*pair<int, int> p1;
    p1.first = 1;
    p1.second = 1;
    pair<int, int> p2;
    p2.first = 5;
    p2.second = 3;
    pair<int, int> p3;
    p3.first = 3;
    p3.second = 4;
    pair<int, int> point1;
    point1.first = 2;
    point1.second = 2;
    pair<int, int> point2;
    point2.first = 1;
    point2.second = 4;*/

    //cout<<"function result 1: "<<endl<<getDistanceBetween2P(p1, p2)<<endl;

    //cout<<"function result: "<<endl<<getSin(p1, p2)<<endl;
    //cout<<"my result: "<<(2/sqrt(20))<<endl;
    //cout<<"function result 1: "<<endl<<isPointInTriangle(p1, p2, p3, p1)<<endl;
    //cout<<"function result 1: "<<endl<<isPointInTriangle(p1, p2, p3, point2)<<endl;

    return 0;
}
